#include "stdafx.h"
#include "windows.h"
#include "stdio.h"

int _tmain(int argc, _TCHAR* argv[])
{
	typedef BOOL (WINAPI* LPGPIO_CONFIG)(UINT8, UINT8, UINT8, UINT8);
	typedef BOOL (WINAPI* LPGPIO_SET)(UINT8, UINT8);
	typedef UINT8 (WINAPI* LPGPIO_GET)(UINT8);
	
	HINSTANCE			hDLL;
	LPGPIO_CONFIG		GPIO_Config;
	LPGPIO_SET			GPIO_Set;
	LPGPIO_GET			GPIO_Get;

	// Load the GPIO DLL
	hDLL = LoadLibrary(TEXT("C:\\Windows\\System\\GPIO"));
	
	// Obtain the exported functions of the GPIO DLL
	if (hDLL != NULL)
	{
		GPIO_Config = (LPGPIO_CONFIG)GetProcAddress(hDLL, "GPIO_Config");
		if (!GPIO_Config)
		{
			printf("GetProcAddress GPIO_Config error: %d\n", GetLastError());
			FreeLibrary(hDLL);
			return -1;
		}

		GPIO_Set = (LPGPIO_SET)GetProcAddress(hDLL, "GPIO_Set");
		if (!GPIO_Set)
		{
			printf("GetProcAddress GPIO_Set error: %d\n", GetLastError());
			FreeLibrary(hDLL);
			return -1;
		}

		GPIO_Get = (LPGPIO_GET)GetProcAddress(hDLL, "GPIO_Get");
		if (!GPIO_Get)
		{
			printf("GetProcAddress GPIO_Get error: %d\n", GetLastError());
			FreeLibrary(hDLL);
			return -1;
		}

	}
	else
		printf("LoadLibrary error: %d\n", GetLastError());

	// Configure GPIO1 as output with pull-up enabled and pull-down disabled
	if (!(GPIO_Config(1, 1, 1, 0))) {
		FreeLibrary(hDLL);
		printf("GPIO_Config Error\n");
		return 0;
	}

	// Configure GPIO2 as input with pull-up enabled and pull-down disabled
	if (!(GPIO_Config(2, 0, 1, 0))) {
		FreeLibrary(hDLL);
		printf("GPIO_Config Error\n");
		return 0;
	}

    // Set GPIO1 output pin to HIGH
	printf("Set GPIO1 - 1\n");
	if (!(GPIO_Set(1, 1))) {
		FreeLibrary(hDLL);
		printf("GPIO_Set Error\n");
		return 0;
	}
	Sleep(100);
	// read the GPIO2
	printf("Get GPIO2 - %d\n\n", GPIO_Get(2));

    // Set GPIO1 output pin to LOW
	printf("Set GPIO1 - 0\n");
	if (!(GPIO_Set(1, 0))) {
		FreeLibrary(hDLL);
		printf("GPIO_Set Error\n");
		return 0;
	}
	Sleep(100);
	// Read the GPIO2
	printf("Get GPIO2 - %d\n\n", GPIO_Get(2));

	FreeLibrary(hDLL);

	return 0;
}

